# -*- coding: utf-8 -*-
"""
Created on Thu Sep 19 10:51:59 2019

@author: amton
"""

import pandas as pd
import datetime
from .checkParameterDifs import checkParameterDifs


def checkDMS_difs(logger, thredds_url, filename):

    df = pd.DataFrame(columns=['Opwerking', 'Instrument', 'Location1',
                               'Location2', 'Parameter', 'Date', 'Url1', 'Url2', 'inRange', 'errStr'])

    checklist = pd.read_csv(filename, skiprows=0, sep=";", header=0)

    enddate = pd.to_datetime(pd.datetime.now().strftime('%Y-%m-%d'))

    for i in range(len(checklist)):

        opwerking = checklist['Opwerking'][i]
        inst = checklist['Instrument'][i]
        loc1 = checklist['Location1'][i]
        loc2 = checklist['Location2'][i]
        parName = checklist['Parameter'][i]

        begindays = int(checklist['Begintime'][i])
        t1 = enddate + pd.to_timedelta(begindays, unit='d')
        enddays = int(checklist['Endtime'][i])
        t2 = enddate + pd.to_timedelta(enddays, unit='d')

        t = t1
        dt = checklist['Timestep'][i]

        lowerLimit = checklist['Lower'][i]
        upperLimit = checklist['Upper'][i]
        errorValue = checklist['Errorvalue'][i]
        ignoreNaN = checklist['IgnoreNaN'][i]

        while 1:

            if t > t2:
                break
            datestr = '{0:04}'.format(t.year) + '{0:02}'.format(t.month) + \
                '{0:02}'.format(t.day) + '{0:02}'.format(t.hour) + '0000'
            url1 = 'thredds_url' + opwerking + '/'+inst+'/' + \
                loc1 + '/'+inst+'_' + loc1 + '_' + datestr + '.nc'
            url2 = 'thredds_url' + opwerking + '/'+inst+'/' + \
                loc2 + '/'+inst+'_' + loc2 + '_' + datestr + '.nc'

            # checkParameterDifs(url1,url2,parName,lowerLimit,upperLimit,errorValue=-999,meanVal=False,ignoreNaN=True):
            inRange, errStr = checkParameterDifs(
                url1, url2, parName, lowerLimit, upperLimit, errorValue, ignoreNaN)

            logger.info(opwerking+';'+inst+';'+loc1+';'+loc2+';' +
                        parName+';'+url1+';'+url2+';'+str(inRange)+';'+errStr+'\n')

            row = [opwerking, inst, loc1, loc2, parName, datestr,
                   url1, url2, str(inRange), errStr]
            df.loc[len(df)] = row

            t = t+datetime.timedelta(hours=int(dt))

    return df
